package com.scbfkj.uni.service;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.scbfkj.uni.library.DataFormatUtil;
import org.junit.jupiter.api.Test;
import org.springframework.boot.test.context.SpringBootTest;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import static org.junit.jupiter.api.Assertions.*;

@SpringBootTest
class DataProcessServiceTest {

    @Test
    void getParams() throws JsonProcessingException {
        List<Object> params = DataProcessService.getParams("$.a[0];;$.c", """
                {"a":[{"b":10}],"c":{"d":"20"}}""");
        System.out.println(params);
    }

    @Test
    void processByAlgorithmByDB0() throws Exception {

        Map<String, Object> map = DataProcessService.processByAlgorithm(new HashMap<>() {{
            put("algorithmlibraryid", 1);
            put("serviceid", 1);
            put("algorithmtype", 3);
            put("computingexpression", "log_error");
            put("parameterset", "$.datasource.connectset;;$.algorithm.computingexpression;;$.args[1].returnData;;$.algorithm.executionnumber");
            put("preconditions", null);
            put("executionnumber", "0");
            put("datasourceid", "1");
        }}, new ArrayList<>() {{
            add(null);
            add(new HashMap<>() {{
                put("returnData", new ArrayList<>() {{
                    add(new HashMap() {{
                        put("id", 15);
                    }});
                }});
            }});
        }}, null, null);

        System.out.println(map);

    }
    @Test
    void processByAlgorithmByDB1() throws Exception {

        Map<String, Object> map = DataProcessService.processByAlgorithm(new HashMap<>() {{
            put("algorithmlibraryid", 1);
            put("serviceid", 1);
            put("algorithmtype", 3);
            put("computingexpression", "log_error");
            put("parameterset", "$.datasource.connectset;;$.algorithm.computingexpression;;$.args[1].returnData;;$.algorithm.executionnumber");
            put("preconditions", null);
            put("executionnumber", "1");
            put("datasourceid", "1");
        }}, new ArrayList<>() {{
            add(null);
            add(new HashMap<>() {{
                put("returnData", new ArrayList<>() {{
                    add(new HashMap() {{
                        put("id", 17);
                    }});
                }});
            }});
        }}, null, null);

        System.out.println(map);

    }
    @Test
    void processByAlgorithmByDB2() throws Exception {

        Map<String, Object> map = DataProcessService.processByAlgorithm(new HashMap<>() {{
            put("algorithmlibraryid", 1);
            put("serviceid", 1);
            put("algorithmtype", 3);
            put("computingexpression", "log_error");
            put("parameterset", "$.datasource.connectset;;$.algorithm.computingexpression;;$.args[1].returnData;;$.algorithm.executionnumber");
            put("preconditions", null);
            put("executionnumber", "2");
            put("datasourceid", "1");
        }}, new ArrayList<>() {{
            add(null);
            add(new HashMap<>() {{
                put("returnData", new ArrayList<>() {{
                    add(new HashMap() {{
                        put("value", new HashMap<String,Object>(){{
                            put("serviceId",1001);
                        }});
                        put("filter", new HashMap<String,Object>(){{
                            put("id",17);
                        }});
                    }});
                }});
            }});
        }}, null, null);

        System.out.println(DataFormatUtil.toString(map));

    }
    @Test
    void processByAlgorithmByDB3() throws Exception {

        Map<String, Object> map = DataProcessService.processByAlgorithm(new HashMap<>() {{
            put("algorithmlibraryid", 1);
            put("serviceid", 1);
            put("algorithmtype", 3);
            put("computingexpression", "log_error");
            put("parameterset", "$.datasource.connectset;;$.algorithm.computingexpression;;$.args[1].returnData;;$.algorithm.executionnumber");
            put("preconditions", null);
            put("executionnumber", "3");
            put("datasourceid", "1");
        }}, new ArrayList<>() {{
            add(null);
            add(new HashMap<>() {{
                put("returnData", new ArrayList<>() {{
                    add(new HashMap() {{
                        put("value", new HashMap<String,Object>(){{
                            put("serviceId",1001);
                        }});
                        put("filter", new HashMap<String,Object>(){{
                            put("id",17);
                        }});
                    }});
                }});
            }});
        }}, null, null);

        System.out.println(DataFormatUtil.toString(map));

    }
}